# This is statement is required by the build system to query build info

if __name__ == '__build__':
	raise Exception

import sys
from OpenGL.GLUT import *
from OpenGL.GL import *
from OpenGL.GLU import *

import MolecularSurfaceView
import SimpleCamera


class SimpleEnvironment:
	myview = None
	def __init__(self):
		#Load up cameras.
		glShadeModel(GL_SMOOTH)
		glEnable(GL_LIGHTING)
		glEnable(GL_DEPTH_TEST)
		glColorMaterial(GL_FRONT, GL_AMBIENT)
		glEnable(GL_COLOR_MATERIAL)
		glMaterialfv(GL_FRONT, GL_SHININESS, 128.0) ##range:0-128
		glMaterialfv(GL_FRONT, GL_SPECULAR, (0.0, 0.5, 1.0, 1.0))	##set material properties
		glClearColor(0.0, 0.0, 0.0, 0.0)
		self.myview = MolecularSurfaceView.MolecularSurfaceView("u:/")
		self.myview.setBaseFileName("decal-1867")
		self.myview.loadSurfaces()
		pass

	def display(self):
		#Run the OpenGL display. GLTeapot this beatch...
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
		glMatrixMode(GL_PROJECTION)
		glLoadIdentity()
		gluPerspective(50, 4/3, 0, 100)
		glMatrixMode(GL_MODELVIEW)
		
		#Update a localized camera here.
		gluLookAt(0,0.0,100, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0)
		glLoadIdentity()
		glColor(1.0, 1.0, 0)

		#glutWireTeapot(.25)
		self.myview.Draw()
		glutSwapBuffers()

	def mouse(self, button, state, x, y):
		pass
	
	def keyboard(self, arg1, arg2, arg3):
		print arg1
		print arg2
		print arg3
		pass
		
	def reshape(self, w, h):
		glViewport(0, 0, w, h)
		glutPostRedisplay();


env = SimpleEnvironment()
glutInit(sys.argv)
glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB)
glutInitWindowSize(450,400)
glutInitWindowPosition(100, 100)
glutCreateWindow('Camera World')
glutDisplayFunc(env.display)
glutReshapeFunc(env.reshape)
glutMouseFunc(env.mouse)
glutKeyboardFunc(env.keyboard)
glutMainLoop()



