

from pymol.opengl.gl import *
import Decal

#DecalList type for python
#Sorta a hack for lack of enum in python. 
#Can refer to the type by name with the _type version
#Can compare to the array itself.

DecalListType_pocket = [0, "pocket"]
DecalListType_shadow = [1, "shadow"]
DecalListType_user = [2, "user"]
DecalListType_sanded = [3, "sanded"]
DecalListType_sanded_region = [4, "sandedregion"]
DecalListType_h_bond_donor = [5, "hbonddonor"]
DecalListType_h_bond_acceptor = [6, "hbondacceptor"]
DecalListType_text = [7, "text"]
DecalListType_unknown = [-1, ""]

DecalListType = [ [0, "pocket"], \
				  [1, "shadow"], \
				  [2, "user"], \
				  [3, "sanded"], \
				  [4, "sandedregion"], \
				  [5, "hbonddonor"], \
				  [6, "hbondacceptor"], \
				  [7, "text"], \
				  [-1, ""] \
				]


DECAL_LIST_TYPE = "type"
DECAL = "decal"

class DecalList:
		
	numUniqueImages = 0
	listType = DecalListType_unknown
	children = []
	gllist = None
	listsbuilt = False
	
	def __init__(self, zipfile, listNode, sd):
	
		#Create a dictionary of images
		images = {}
	
		type = listNode.attrib[DECAL_LIST_TYPE]		
		
		for i in range(0, len(DecalListType)):
			if (type == DecalListType[i][1]):
				self.listType = DecalListType[i]
		
		self.children = []
		for decalNode in listNode.getchildren():		
			if (decalNode.tag == DECAL) and (len(decalNode.getchildren()) > 0):
				self.children.append(Decal.Decal(zipfile, decalNode, sd, images))
			
		self.numUniqueImages = len(images)
		
	
		
	def getNumUniqueImages(self):
		return self.numUniqueImages
		
	def buildLists(self):
		self.gllist = glGenLists(1)
		#print "DecalList: ",
		#print self.gllist
		glNewList(self.gllist, GL_COMPILE)
		for child in self.children:
			child.Render()
		glEndList()
		self.listsbuilt = True
		
	def Render(self):
		if not self.listsbuilt:
			self.buildLists()
		glCallList(self.gllist)