
#A good old 3D Vector class to satisfy a lot of code.
#This is a python translation of the JOGL Vector3D as close
#as linguistically possible to make porting easy.

#I guess that's GPL2d, but who knows how this will affect this code.

import math
import types

class Vector3D:
	x = 0.0
	y = 0.0
	z = 0.0
	w = 1.0
	
	def __init__(self, arg0 = None, arg1 = None, arg2 = None):		
		if isinstance(arg0, types.InstanceType) == True:		
			self.x = arg0.x
			self.y = arg0.y
			self.z = arg0.z
			return
		if not (arg0 == None):
			self.x = arg0
		if not (arg1 == None):
			self.y = arg1
		if not (arg2 == None):
			self.z = arg2
		#print self.x
		#print self.y
		#print self.z
	
	def set(self, x, y, z):
		self.x = x
		self.y = y
		self.z = z
		
	def get(self):
		v = [self.x, self.y, self.z, self.w]
		return v

	def add(self, vector):
		self.x = self.x + vector.x
		self.y = self.y + vector.y
		self.z = self.z + vector.z
		
	def subtract(self, vector):
		self.x = self.x - vector.x
		self.y = self.y - vector.y
		self.z = self.z - vector.z
		
		
	def multiply(self, scalar):
		self.x = self.x * scalar
		self.y = self.y * scalar
		self.z = self.z * scalar
	
	def equals(self, vector):
		if not self.x == vector.x:
			return false
		if not self.y == vector.y:
			return false
		if not self.z == vector.z:
			return false
		if not self.w == vector.w:
			return false
		
	def length(self):
		return math.sqrt(self.x*self.x + self.y*self.y + self.z*self.z)
		
	def dot(self, vec):
		return self.x * vec.x + self.y * vec.y + self.z * vec.z
	
	
	def cross(self, vec):
		t0 =  self.y * vec.z - self.z * vec.y
		t1 = -self.x * vec.z + self.z * vec.x
		t2 =  self.x * vec.y - self.y * vec.x
		
		self.x = t0
		self.y = t1
		self.z = t2
		self.w = 1.0
		
	def cross2(self, vec1, vec2):
		t0 =  vec1.y * vec2.z - vec1.z * vec2.y
		t1 = -vec1.x * vec2.z + vec1.z * vec2.x
		t2 =  vec1.x * vec2.y - vec1.y * vec2.x
		
		self.x = t0
		self.y = t1
		self.z = t2
		self.w = 1.0
		
	def normalize(self):
		len = self.length()
		if (len == 0):
			return
		self.x = self.x / len
		self.y = self.y / len
		self.z = self.z / len
		self.w = 1
		
	def average(self, vecList):
		vector_count = len(vecList)
		if ((vecList == None) or (vector_count == 0)):
			print "WARNING: average of empty list in Vector3D.average"
			self.x = 0.0
			self.y = 0.0
			self.z = 0.0
			self.w = 1.0
			return
		
		x_total = 0.0
		y_total = 0.0
		z_total = 0.0
		
		for vec in vecList:
			x_total += vec.x
			y_total += vec.y
			z_total += vec.z
		len
		self.x = x_total/vector_count
		self.y = y_total/vector_count
		self.z = z_total/vector_count
		