
from pymol.opengl.gl import *
from pymol.callback import Callback
import MolecularSurfaceView

class ViewerCallback(Callback):
	viewer = None
	extent = [[0.0,0.0,0.0],[0.0,0.0,0.0]]
	
	def __init__(self, view):
		self.viewer = view
		if (view):
			self.setExtents(view)
		
	def __call__(self):
		#Call the molecular drawing functions here
		#print self.viewer == None
		if (self.viewer):
			self.viewer.Draw()
		
		
		
	def setView(self, view):
		self.viewer = view
		self.setExtents(view)
		
		
	def setExtents(self, view):
		#Query the view module for extents.
		minX = float("+inf")
		minY = float("+inf")
		minZ = float("+inf")
	
		maxX = float("-inf")
		maxY = float("-inf")
		maxZ = float("-inf")
		
		#Get the largest/smallest extents from the surfaces. Convenient!
		for sc in view.surfaceCollections:			
			surf = sc.getSurface()
			if (surf):
				maxX = max(maxX, surf.maxX)
				maxY = max(maxY, surf.maxY)
				maxZ = max(maxZ, surf.maxZ)
				
				minX = min(minX, surf.minX)
				minY = min(minY, surf.minY)
				minZ = min(minZ, surf.minZ)
				
				self.extent = [[minX, minY, minZ], [maxX, maxY, maxZ]]
		print "Extents: ",
		print self.extent
		
		
	def get_extent(self):
		print self.extent
		return self.extent